module GeometryFunctions exposing (insideTriangle, leftRightOrOnLine, pointOnLineClosestTo)

import GeometryTypes exposing (..)


leftRightOrOnLine : DirectedLine -> Vector -> Int
leftRightOrOnLine line v =
    if v.x < line.from.x then
        -1

    else if v.x > line.from.x then
        1

    else
        0


insideTriangle : Triangle -> Vector -> Bool
insideTriangle triangle v =
    v.x < triangle.a.x


pointOnLineClosestTo : DirectedLine -> Vector -> Vector
pointOnLineClosestTo line v =
    { x = 2 * line.from.x - v.x, y = 2 * line.from.y - v.y }
